unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls,Math, Buttons, ToneGen;

type
//data used for demos
DemoData=record
   Wave: TTGWave;
   Dur: Integer;
   Freq: Integer;
   A,D,S,R: Integer;
   Reps: Integer;
   end;


  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    UpDown1: TUpDown;
    Edit1: TEdit;
    Label1: TLabel;
    RadioGroup3: TRadioGroup;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    Label7: TLabel;
    Panel1: TPanel;
    Label3: TLabel;
    Panel2: TPanel;
    Label4: TLabel;
    Panel3: TPanel;
    Label5: TLabel;
    Panel4: TPanel;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Label6: TLabel;
    Button6: TButton;
    ToneGen1: TToneGen;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Timer2: TTimer;
    Button12: TButton;
    Timer3: TTimer;
    Button13: TButton;
    Button14: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    Label8: TLabel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Label10: TLabel;
    Bevel2: TBevel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  DD: array [0 .. 9] of DemoData;
  Demo: Integer;
  PanRight: bool;
  //tune data
  notes: array [0..13] of Smallint=(0,0,7,7,9,9,7,5,5,4,4,2,2,0);
  //note intervals
  interval: array[0..13] of Smallint=(500,500,500,500,500,500,1000,500,500,500,500,500,500,500);
  notepos: Integer;
implementation

{$R *.DFM}

//exit
procedure TForm1.Button1Click(Sender: TObject);
begin
Close;
end;


//draw envelope graphic
procedure RedrawADSR;
var
   bleft,btop,apos,dpos,spos,rpos,wdth,hgt,total: Integer;
   xs,xe,ys,ye: Integer;
   fmc: TCanvas;

begin

with Form1 do
    begin
    wdth:=Bevel1.Width-1;
    hgt:=Bevel1.Height-1;
    bleft:=Bevel1.Left+1;
    btop:=Bevel1.Top+1;

    fmc:=Form1.Canvas;

    apos:=100-trackbar1.Position;
    dpos:=100-trackbar2.Position;
    spos:=trackbar3.Position;
    rpos:=100-trackbar4.Position;

    total:=apos+dpos+rpos;

    if total>100 then
       begin
       apos:=apos * 100 div total;
       dpos:=dpos * 100 div total;
       rpos:=rpos * 100 div total;
       end;


    //attack
    fmc.Pen.Color:=clRed;
    xs:=bleft;
    xe:=bleft+(wdth * apos div 100);
    ys:=btop+hgt;
    ye:=btop;
    fmc.MoveTo(xs,ys);
    fmc.LineTo(xe,ye);

    //decay
    fmc.Pen.Color:=clBlue;
    xe:=xe+(wdth * dpos div 100);
    ye:=btop+(hgt * spos div 100);
    fmc.LineTo(xe,ye);

    //sustain
    fmc.Pen.Color:=clGreen;
    if total<100 then
       begin
       xe:=(bleft+wdth)-(wdth * rpos div 100);
       fmc.LineTo(xe,ye);
       end;

    //release
    fmc.Pen.Color:=clNavy;
    xe:=bleft+wdth;
    ye:=btop+hgt;
    fmc.LineTo(xe,ye);

    end;

end;

procedure TForm1.FormActivate(Sender: TObject);
begin

TrackBar1Change(nil);
end;

//set async state from loop
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
CheckBox2.Enabled:=not CheckBox1.Checked;
end;

//set ADSR
procedure TForm1.TrackBar1Change(Sender: TObject);
var
   tb1,tb2,tb3,tb4,Total: Integer;

begin
tb1:=100-TrackBar1.Position;
tb2:=100-TrackBar2.Position;
tb3:=100-TrackBar3.Position;
tb4:=100-TrackBar4.Position;

Total:=tb1+tb2+tb4;


with ToneGen1 do
     begin
     Attack:=tb1;
     Decay:=tb2;
     Sustain:=tb3;
     Release:=tb4;
     end;


if Total>100 then
   begin
   tb1:=tb1 * 100 div Total;
   tb2:=tb2 * 100 div Total;
   tb4:=tb4 * 100 div Total;
   end;

Panel1.Caption:=IntToStr(tb1)+'%';
Panel2.Caption:=IntToStr(tb2)+'%';
Panel3.Caption:=IntToStr(tb3)+'%';
Panel4.Caption:=IntToStr(tb4)+'%';


//update graphic
Form1.Bevel2.Invalidate;
Update;

end;

procedure TForm1.FormPaint(Sender: TObject);
begin
RedrawADSR;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//set volume
TrackBar5.Position:=100-ToneGen1.LeftVolume;
TrackBar6.Position:=100-ToneGen1.RightVolume;

Randomize;
//initialise demo records
//morse
with DD[0] do
     begin
     Freq:=440;
     Dur:=100;
     Wave:=tgSine;
     A:=0;
     D:=0;
     S:=100;
     R:=0;
     end;

//alarm
with DD[1] do
     begin
     Freq:=1500;
     Dur:=200;
     Wave:=tgTriangle;
     A:=0;
     D:=20;
     S:=80;
     R:=0;
     end;

//pan
with DD[2] do
     begin
     Freq:=100;
     Dur:=100;
     Wave:=tgSquare;
     A:=10;
     D:=15;
     S:=75;
     R:=0;
     end;

//tune
with DD[3] do
     begin
     Freq:=500;
     Dur:=500;
     Wave:=tgSawtooth;
     A:=10;
     D:=15;
     S:=75;
     R:=16;
     end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

end;

//left volume
procedure TForm1.TrackBar5Change(Sender: TObject);
begin
ToneGen1.LeftVolume:=100-TrackBar5.Position;
end;

//right volume
procedure TForm1.TrackBar6Change(Sender: TObject);
begin
ToneGen1.RightVolume:=100-TrackBar6.Position;
end;

//set component parameters from controls
procedure SetupTone;
begin
with Form1.Tonegen1 do
     begin
     Loop:=Form1.CheckBox1.Checked;
     Async:=Form1.CheckBox2.Checked;
     Frequency:=StrToIntDef(Form1.Edit2.Text,440);
     Duration:=StrToIntDef(Form1.Edit1.Text,440);
     if Form1.RadioGroup2.ItemIndex=0 then
        Quality:=tgHiQ
     else
        Quality:=tgLoQ;

     if Form1.RadioGroup1.ItemIndex=0 then
        Resolution:=tg16Bit
     else
        Resolution:=tg8Bit;

     case Form1.RadioGroup3.ItemIndex of
          0: Waveform:=tgSine;
          1: Waveform:=tgSquare;
          2: Waveform:=tgTriangle;
          3: Waveform:=tgSawtooth;
          4: Waveform:=tgNoise;
     end;


     end;

end;

//paly tone
procedure TForm1.Button6Click(Sender: TObject);
begin
SetupTone;
ToneGen1.Play;
end;

//set volume
procedure TForm1.Button7Click(Sender: TObject);
begin
ToneGen1.PresetVolume;
end;

//stop sound
procedure TForm1.Button9Click(Sender: TObject);
begin
Timer2.Enabled:=false;
Timer3.Enabled:=false;
ToneGen1.Stop;
end;

//play ADSR
procedure TForm1.Button8Click(Sender: TObject);
begin
SetupTone;

ToneGen1.PlayADSR;
end;

//setup demo parameters
procedure SetDemo(ID:Integer);
begin

//set data
with Form1.Tonegen1 do
     begin
     Frequency:=DD[ID].Freq;
     Duration:=DD[ID].Dur;
     Waveform:=DD[ID].Wave;
     Attack:=DD[ID].A;
     Decay:=DD[ID].D;
     Sustain:=DD[ID].S;
     Release:=DD[ID].R;

     if ID<>4 then
        begin
        Loop:=false;
        Async:=true;
        end
     else
        begin
        Loop:=Form1.Checkbox1.Checked;
        Async:=Form1.Checkbox2.Checked;
        end;
     end;

//setup controls
with Form1 do
     begin
     Edit2.Text:=IntToStr(DD[ID].Freq);
     Edit1.Text:=IntToStr(DD[ID].Dur);
     Trackbar1.Position:=100-DD[ID].A;
     Trackbar2.Position:=100-DD[ID].D;
     Trackbar3.Position:=100-DD[ID].S;
     Trackbar4.Position:=100-DD[ID].R;
     Radiogroup3.ItemIndex:=Integer(DD[ID].Wave);
     end;

Form1.Timer2.Enabled:=false;
Form1.Timer3.Enabled:=false;

//random
if ID<>4 then
   begin
   Form1.Timer2.Enabled:=true;
   end;

if ((ID=4) and Form1.Tonegen1.Loop) or (ID<>4) then
   Form1.Timer3.Enabled:=true;

Form1.Timer3.Interval:=5000;

//tune
if ID=3 then
   Form1.Timer3.Interval:=10000;

end;

//random
procedure TForm1.Button10Click(Sender: TObject);
begin
Demo:=4;

with DD[Demo] do
     begin
     Freq:=(10+random(1000))*10;
     Dur:=(10+random(90))*10;
     Wave:=TTGWave(random(5));
     A:=random(101);
     D:=random(101);
     S:=random(101);
     R:=random(101);
     end;

//loop?
if random(2)>0 then
   Checkbox1.Checked:=true
else
   Checkbox1.Checked:=false;


SetDemo(Demo);
Tonegen1.PlayADSR;
end;

//morse
procedure TForm1.Button11Click(Sender: TObject);
begin
Demo:=0;
Timer2.Interval:=100+Random(300);
SetDemo(Demo);
end;

//demo timer
procedure TForm1.Timer2Timer(Sender: TObject);
var
   Base:Integer;

begin
//morse
if Demo=0 then
   begin
   Timer2.Interval:=50+Random(300);
   end;

//pan
if Demo=2 then
   begin
   with Tonegen1 do
        begin
        if PanRight then
           begin
           if RightVolume<100 then
              RightVolume:=RightVolume+50
           else
               if LeftVolume>0 then
                  LeftVolume:=LeftVolume-50
               else
                   PanRight:=false;
           end
        else
            begin
                 if LeftVolume<100 then
                    LeftVolume:=LeftVolume+50
           else
               if RightVolume>0 then
                  RightVolume:=RightVolume-50
               else
                   PanRight:=true;
           end;

        PresetVolume;
        Trackbar5.Position:=100-LeftVolume;
        Trackbar6.Position:=100-RightVolume;

        end;

   end;

//tune
if Demo=3 then
   begin
   if Notepos>13 then Exit;

   //calculate frequency from note
   Base:=523;
   Tonegen1.Frequency:=Trunc(base * Power(2,notes[Notepos]/12));
   Timer2.Interval:=interval[notepos];
   Notepos:=Notepos+1;

   end;

Tonegen1.PlayADSR;
end;

//alarm
procedure TForm1.Button12Click(Sender: TObject);
begin
Demo:=1;
Timer2.Interval:=400;
SetDemo(Demo);

end;

//demo overall duration
procedure TForm1.Timer3Timer(Sender: TObject);
begin
Timer3.Enabled:=false;
Timer2.Enabled:=false;

with Tonegen1 do
     begin
     Stop;
     //set volume after pan
     if Demo=2 then
        begin
        LeftVolume:=100;
        RightVolume:=100;
        Trackbar5.Position:=100-LeftVolume;
        Trackbar6.Position:=100-RightVolume;
        end;
     end;

end;

//pan
procedure TForm1.Button13Click(Sender: TObject);
begin

Tonegen1.LeftVolume:=100;
Tonegen1.RightVolume:=0;
Tonegen1.PresetVolume;

Demo:=2;
SetDemo(Demo);
PanRight:=true;

Timer2.Interval:=200;
Timer2.Enabled:=true;

end;

//tune
procedure TForm1.Button14Click(Sender: TObject);
begin
Demo:=3;
Notepos:=0;
SetDemo(Demo);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Application.HelpFile := ExtractFilePath(Application.ExeName)+'TTonegen.hlp';
Application.HelpCommand(HELP_CONTENTS, 0);

end;

end.
